package ca.mcgill.cs.swevo.diffcat.view;

import org.eclipse.core.runtime.IAdaptable;

/*
 * The content provider class is responsible for
 * providing objects to the view. It can wrap
 * existing objects in adapters or simply return
 * objects as-is. These objects may be sensitive
 * to the current input of the view, or ignore
 * it and always show the same content 
 * (like Task List, for example).
 */
 
class TreeObject implements IAdaptable {
	
	private String name;
	private TreeParent parent;
	
	public TreeObject(String name) {
		this.name = name;
	}
	public String getName() {
		return name;
	}
	public void setParent(TreeParent parent) {
		this.parent = parent;
	}
	public TreeParent getParent() {
		return parent;
	}
	public String toString() {
		return getName();
	}
	public Object getAdapter(Class key) {
		return null;
	}
	public boolean equals (Object o) {
		if (o == this) {
			return true;
		}
		if (o == null || ! o.getClass().equals(this.getClass())) {
			return false;
		}
		TreeObject obj = (TreeObject) o;
		return obj.getName().equals(getName());
	}
}
