/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.view.preferences;

/**
 * Constant definitions for plug-in preferences
 */
public class PreferenceConstants {

	public static final String P_PATH = "pathPreference";

	public static final String P_BOOLEAN = "booleanPreference";

	public static final String P_CHOICE = "choicePreference";

	public static final String P_STRING = "stringPreference";
	
	// ----- Filter preferences ----------------------------------
	
	public static final String P_FILTER_SHOW_RENAME_INDUCED 	= "pFilterShowRenameInduced";
	public static final String P_FILTER_SHOW_TRIVIAL_THIS   	= "pFilterShowTrivialThis";
	public static final String P_FILTER_SHOW_DOCUMENT_DIFFS 	= "pFilterShowDocumentDiffs";
	public static final String P_FILTER_SHOW_VARIABLE_RENAMES	= "pFilterShowVarRenames";
	public static final String P_FILTER_SHOW_PARAM_RENAMES		= "pFilterShowParamRenames";
	public static final String P_FILTER_SHOW_FIELD_RENAMES		= "pFilterShowAttrRenames";
	public static final String P_FILTER_SHOW_METHOD_RENAMES		= "pFilterShowMethodRenames";
	public static final String P_FILTER_SHOW_TRIVIAL_IF			= "pFilterShowTrivialIf";
	
	// ----- Edge Type preferences -------------------------------
	
	public static final String P_REFERENCE_EDGE_WEIGHT 		= "pReferenceEdgeWeight";
	public static final String P_HIERARCHY_EDGE_WEIGHT 		= "pHierarchyEdgeWeight";
	public static final String P_CONTAINMENT_EDGE_WEIGHT 	= "pContainmentEdgeWeight";
	public static final String P_DIRECT_EDGE_WEIGHT 		= "pDirectEdgeWeight";
	public static final String P_STRUCT_SIM_EDGE_WEIGHT 	= "pStructSimEdgeWeight";
	public static final String P_VARIABLE_EDGE_WEIGHT		= "pVariableEdgeWeight";
	public static final String P_SOURCE_EDGE_WEIGHT			= "pSourceEdgeWeight";
	public static final String P_SINK_EDGE_WEIGHT			= "pSinkEdgeWeight";
	public static final String P_CLONE_EDGE_WEIGHT			= "pCloneEdgeWeight";
	public static final String P_SIG_EDGE_WEIGHT			= "pSigEdgeWeight";
}
