package ca.mcgill.cs.swevo.diffcat.view.preferences;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;

import ca.mcgill.cs.swevo.diffcat.view.Activator;

/**
 * Class used to initialize default preference values.
 */
public class PreferenceInitializer extends AbstractPreferenceInitializer {

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer#initializeDefaultPreferences()
	 */
	public void initializeDefaultPreferences() {
		IPreferenceStore store = Activator.getDefault().getPreferenceStore();
		store.setDefault(PreferenceConstants.P_BOOLEAN, true);
		store.setDefault(PreferenceConstants.P_CHOICE, "choice2");
		store.setDefault(PreferenceConstants.P_STRING, "Default value");
		
		// Diff Filters
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_RENAME_INDUCED, true);
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_TRIVIAL_THIS, true);
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_DOCUMENT_DIFFS, true);
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_VARIABLE_RENAMES, true);
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_FIELD_RENAMES, true);
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_METHOD_RENAMES, true);
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_TRIVIAL_IF, true);
		store.setDefault(PreferenceConstants.P_FILTER_SHOW_PARAM_RENAMES, true);
		
		// Edge Weights
		store.setDefault(PreferenceConstants.P_CONTAINMENT_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_DIRECT_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_HIERARCHY_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_REFERENCE_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_STRUCT_SIM_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_SINK_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_SOURCE_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_VARIABLE_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_CLONE_EDGE_WEIGHT, 1);
		store.setDefault(PreferenceConstants.P_SIG_EDGE_WEIGHT, 1);
	}

}
