/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.cd;

import org.eclipse.jdt.core.dom.ASTVisitor;
import org.eclipse.jdt.core.dom.MethodDeclaration;

public class ConstructorNameChanger extends ASTVisitor {

	private final String nameToMatch;
	private final String nameToSet;
	
	public ConstructorNameChanger (String nameToMatch, String nameToSet) {
		this.nameToMatch = nameToMatch;
		this.nameToSet = nameToSet;
	}
	
	public boolean visit (MethodDeclaration methodDeclaration) {
		
		String nameToMatch = methodDeclaration.getName().getIdentifier();
		if (this.nameToMatch.equals(nameToMatch)) {
			methodDeclaration.getName().setIdentifier(nameToSet);
		}
		
		return true;
	}
}

