package ca.mcgill.cs.swevo.diffcat.cd.finder;

import java.util.LinkedList;
import java.util.List;

import org.eclipse.jdt.core.dom.MethodDeclaration;
import org.evolizer.changedistiller.model.entities.SourceCodeEntity;
import org.evolizer.changedistiller.model.entities.StructureEntityVersion;

import ca.mcgill.cs.swevo.diffcat.util.ast.ASTUtil;
import ca.mcgill.cs.swevo.diffcat.util.binding.BindingUtil;

public class HeuristicMethodInsertFinder extends ANodeFinder {

	private String   declName;
	private String[][] declTypeArgs;
	private String[] declType;
	
	List<MethodDeclaration> secondaries = new LinkedList<MethodDeclaration>();
	
	/**
	 * Initialize a new MethodDeclarationFinder
	 * @param methodDecl METHOD_DECLARATION of the form fqn.name(arg1,...,arg2)
	 */
	public HeuristicMethodInsertFinder (SourceCodeEntity methodDecl)
	{
		this.declName 		= CDUtil.getMethodName(methodDecl);
		this.declTypeArgs	= CDUtil.getMethodParameterTypes(methodDecl);
		this.declType 		= CDUtil.getMethodDeclaringType(methodDecl);
	}
		
	public boolean visit (MethodDeclaration node) {
		String 	 declName = null;
		String[][] declTypeArgs = null;
		
		declName = ASTUtil.getMethodName(node);
		
		if (! declName.equals(this.declName)) {
			return true;
		}
	
		declTypeArgs = ASTUtil.getParamTypesViaBindings(node);
		
		if (declTypeArgs.length == this.declTypeArgs.length) {
			secondaries.add(node);
		}
		
		return true;
	}
	
	public List<MethodDeclaration> getSecondaries () {
		return secondaries;
	}
}
