package ca.mcgill.cs.swevo.diffcat.cd.finder;

import org.eclipse.jdt.core.dom.ASTNode;
import org.eclipse.jdt.core.dom.LabeledStatement;
import org.evolizer.changedistiller.model.entities.SourceCodeEntity;

public class LabelledStatementFinder extends ANodeFinder  {

	private final ASTNode methodDecl;
	private boolean stopVisiting;
	private final String label;
	
	public LabelledStatementFinder (SourceCodeEntity statement, ASTNode methodDecl) {
		this.label = statement.getUniqueName();
		this.methodDecl = methodDecl;
		this.stopVisiting = false;
	}
	
	public boolean visit(LabeledStatement s) {
		
		if (stopVisiting) {
			return false;
		}
		
		if (! super.inCorrectMethodDecl(s, methodDecl)) {
			return false;
		}
		
		if (s.getLabel().toString().equals(label)) {
			stopVisiting = true;
			super.assocNode = s;
			return false;
		}
		
		return true;
	}

}
