/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.util;

import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class CastConverter <F, T extends F> {

	@SuppressWarnings("unchecked")
	public List<T> downCast(List<F> list) {
		
		List<T> result = new ArrayList<T>(list.size());
		
		for (F f : list) {
			result.add ((T) f);
		}
		
		return result;
	}
	
	@SuppressWarnings("unchecked")
	public Set<T> downCast(Set<F> list) {
		
		Set<T> result = new HashSet<T>();
		
		for (F f : list) {
			result.add ((T) f);
		}
		
		return result;
	}
}
