/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.util.filter;

import ca.mcgill.cs.swevo.diffcat.model.ChangeOperation;
import ca.mcgill.cs.swevo.diffcat.model.DiffCatResult;
import ca.mcgill.cs.swevo.util.filter.IFilter;

public class IsRenameFilter implements IFilter<DiffCatResult> {

	@Override
	public boolean passesFilter(DiffCatResult t) {
		String change = t.getChangeType();
		return 
			change.equals(ChangeOperation.CLASS_NAME_UPDATE.name())||
			change.equals(ChangeOperation.METHOD_NAME_UPDATE.name())||
			change.equals(ChangeOperation.ATTRIBUTE_NAME_UPDATE.name())||
			change.equals(ChangeOperation.PARAMETER_NAME_UPDATE.name())||
			change.equals(ChangeOperation.VARIABLE_NAME_UPDATE.name());
	}

}
