/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.util.binding;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.dom.IAnnotationBinding;
import org.eclipse.jdt.core.dom.IBinding;
import org.eclipse.jdt.core.dom.IMethodBinding;
import org.eclipse.jdt.core.dom.ITypeBinding;

public class FakeMethodBinding implements IMethodBinding {

	private ITypeBinding declaringClass = FakeTypeBinding.getObjectTypeBinding();
	private String name = "default";
	private List<ITypeBinding> parameterTypes = new ArrayList<ITypeBinding>();
	
	public void setDeclaringClass (ITypeBinding declaringClass) {
		this.declaringClass = declaringClass;
	}
	
	public void setName (String name) {
		this.name = name;
	}
	
	public void setParameterTypes (List<ITypeBinding> parameterTypes) {
		this.parameterTypes = new ArrayList<ITypeBinding>(parameterTypes);
	}
	
	@Override
	public IAnnotationBinding[] getAnnotations() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IJavaElement getJavaElement() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getKey() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getKind() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public int getModifiers() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public boolean isDeprecated() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isEqualTo(IBinding arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isRecovered() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isSynthetic() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public ITypeBinding getDeclaringClass() {
		return declaringClass;
	}

	@Override
	public Object getDefaultValue() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding[] getExceptionTypes() {
		return new ITypeBinding[0];
	}

	@Override
	public IMethodBinding getMethodDeclaration() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public IAnnotationBinding[] getParameterAnnotations(int arg0) {
		return new IAnnotationBinding[0];
	}

	@Override
	public ITypeBinding[] getParameterTypes() {
		return parameterTypes.isEmpty() ? 
				new ITypeBinding[0] : 
				parameterTypes.toArray(new ITypeBinding[parameterTypes.size()]);
	}

	@Override
	public ITypeBinding getReturnType() {
		return FakeTypeBinding.getObjectTypeBinding();
	}

	@Override
	public ITypeBinding[] getTypeArguments() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding[] getTypeParameters() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean isAnnotationMember() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isConstructor() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isDefaultConstructor() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isGenericMethod() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isParameterizedMethod() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isRawMethod() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isSubsignature(IMethodBinding arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isVarargs() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean overrides(IMethodBinding arg0) {
		// TODO Auto-generated method stub
		return false;
	}

}
