/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.diffcat.util.binding;

import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.dom.IAnnotationBinding;
import org.eclipse.jdt.core.dom.IBinding;
import org.eclipse.jdt.core.dom.IMethodBinding;
import org.eclipse.jdt.core.dom.IPackageBinding;
import org.eclipse.jdt.core.dom.ITypeBinding;
import org.eclipse.jdt.core.dom.IVariableBinding;

public class FakeTypeBinding implements ITypeBinding {

	private static final ITypeBinding UNKNOWN_TYPE = new FakeTypeBinding();
	private static final FakeTypeBinding OBJECT_TYPE = new FakeTypeBinding();
	static {
		OBJECT_TYPE.setName("Object");
		OBJECT_TYPE.setPackage("java.lang");
	}
	
	public static ITypeBinding getUnknownTypeBinding () {
		return UNKNOWN_TYPE;
	}
	
	public static ITypeBinding getObjectTypeBinding () {
		return OBJECT_TYPE;
	}
	
	private String name = "UNKNOWN";
	private String pack = "UNKNOWNP";
	
	public void setName (String name) {
		this.name = name;
	}
	
	public void setPackage (String pack) {
		this.pack = pack;
	}
	
	@Override
	public IAnnotationBinding[] getAnnotations() {
		return new IAnnotationBinding[0];
	}

	@Override
	public IJavaElement getJavaElement() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getKey() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getKind() {
		return IBinding.TYPE;
	}

	@Override
	public boolean isDeprecated() {
		return false;
	}

	@Override
	public boolean isEqualTo(IBinding arg0) {
		return false;
	}

	@Override
	public boolean isRecovered() {
		return false;
	}

	@Override
	public boolean isSynthetic() {
		return false;
	}

	@Override
	public ITypeBinding createArrayType(int arg0) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getBinaryName() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getBound() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getComponentType() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IVariableBinding[] getDeclaredFields() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IMethodBinding[] getDeclaredMethods() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getDeclaredModifiers() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public ITypeBinding[] getDeclaredTypes() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getDeclaringClass() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public IMethodBinding getDeclaringMethod() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getDimensions() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public ITypeBinding getElementType() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getErasure() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getGenericTypeOfWildcardType() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding[] getInterfaces() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getModifiers() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public String getName() {
		return name;
	}

	@Override
	public IPackageBinding getPackage() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getQualifiedName() {
		return pack + "." + name;
	}

	@Override
	public int getRank() {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public ITypeBinding getSuperclass() {
		return OBJECT_TYPE;
	}

	@Override
	public ITypeBinding[] getTypeArguments() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding[] getTypeBounds() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getTypeDeclaration() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding[] getTypeParameters() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public ITypeBinding getWildcard() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public boolean isAnnotation() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isAnonymous() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isArray() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isAssignmentCompatible(ITypeBinding arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isCapture() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isCastCompatible(ITypeBinding arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isClass() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isEnum() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isFromSource() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isGenericType() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isInterface() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isLocal() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isMember() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isNested() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isNullType() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isParameterizedType() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isPrimitive() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isRawType() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isSubTypeCompatible(ITypeBinding arg0) {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isTopLevel() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isTypeVariable() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isUpperbound() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public boolean isWildcardType() {
		// TODO Auto-generated method stub
		return false;
	}

}
