/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.util;

public class LRTuple <T> {

	private T left;
	private T right;
	
	public LRTuple (T left, T right) {
		this.left = left;
		this.right = right;
	}
	
	public T getLeft () {
		return left;
	}
	
	public void setLeft (T left) {
		this.left = left;
	}
	
	public T getRight () {
		return right;
	}
	
	public void setRight (T right) {
		this.right = right;
	}
	
	public boolean equals (Object o) {
		if (o == this) {
			return true; 
		}
		if (o == null) {
			return false;
		}
		if (! o.getClass().equals(getClass())) {
			return false;
		}
		
		LRTuple tuple = (LRTuple) o;
		
		Object left = tuple.getLeft();
		Object right = tuple.getRight();
		
		if (! equals(left, getLeft())) {
			return false;
		}
		
		if (! equals(right, getRight())) {
			return false;
		}
		
		return true;
	}
	
	private boolean equals (Object one, Object two) {
		if (one == null) {
			if (two == null) {
				return true;
			} else {
				return false;
			}
		}
		else
		{
			if (two == null) {
				return false;
			} else {
				return one.equals(two);
			}
		}
	}
	
	@Override
	public int hashCode () {
		T left = getLeft();
		T right = getRight();
		return ((left != null ? left.toString().hashCode() : 0) * (right != null ? right.toString().hashCode() : 0)); 
	}
	
	@Override
	public String toString () {
		return (getLeft() != null ? getLeft().toString() : "") + " " + (getRight() != null ? getRight() : "");  
	}
	
	public LRTuple<T> flip () {
		return new LRTuple<T>(right, left);
	}

	public void clear() {
		left = null;
		right = null;
	}
}
