/*******************************************************************************
 * Copyright (c) 2011 David Kawrykow.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     David Kawrykow - initial API and implementation
 ******************************************************************************/
package ca.mcgill.cs.swevo.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LRTupleListMap <K, V> {

	private Map<LRTuple<K>, List<V>> map;
	
	public LRTupleListMap () {
		map = new HashMap<LRTuple<K>, List<V>>();
	}
	
	public boolean containsKey (K left, K right) {
		return map.containsKey(new LRTuple<K>(left, right));
	}
	
	public void addAll (K left, K right, List<V> shells) {
		if (! containsKey(left, right)) {
			map.put(new LRTuple<K> (left, right), new ArrayList<V>(shells.size()));
		}
		
		map.get(new LRTuple<K> (left, right)).addAll(shells);
	}
	
	public List<V> get (K left, K right) {
		return map.get(new LRTuple<K> (left, right));
	}
	
	public void remove (K left, K right) {
		map.remove(new LRTuple<K>(left, right));
	}
}
