package ca.mcgill.cs.swevo.util;

import static org.junit.Assert.assertEquals;

import java.util.Arrays;
import java.util.Collection;
import java.util.Map;
import java.util.Set;

import org.junit.Test;

import ca.mcgill.cs.swevo.util.op.IConverter;

public class TestDirectedGraphUtil {

	@Test
	public void testSimple ()
	{
		IConverter<String, Collection<String>> conv = new IConverter<String, Collection<String>>() {
			@Override
			public Collection<String> convert(String f) {
				if (f.equals("A")) {
					return Arrays.asList("B", "D");
				} else if (f.equals("B")) {
					return Arrays.asList("C");
				} else if (f.equals("C")) {
					return Arrays.asList("A");
				} else if (f.equals("D")) {
					return Arrays.asList("C");
				} else {
					return Arrays.asList("D");
				}
			}
		}; 
		
		Collection<String> nodes = Arrays.asList( "D", "E", "F", "A", "B", "C");
		
		Map<String, Set<String>> map = DirectedGraphUtil.buildTransitiveClosure(nodes, conv);
		
		Set<String> keySet = map.keySet();
		assertEquals (6, keySet.size());
		assertEquals (4, map.get("A").size());
		assertEquals (5, map.get("E").size());
		assertEquals (5, map.get("F").size());
	}
}
